RDKit: RDKit::StructureCheck Namespace Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Classes | Enumerations | Functions | Variables
RDKit::StructureCheck Namespace Reference

## Classes
struct | AugmentedAtom
class | ChargeFix
struct | IncEntry
struct | Ligand
struct | Neighbourhood
struct | PathEntry
class | StructChecker
| Class for performing structure validation and cleanup. More...
struct | StructCheckerOptions
class | StructCheckTautomer

## Enumerations
enum | RadicalType { RT_NONE = 0 , SINGLET = 1 , DOUBLET = 2 , TRIPLET = 3 , ANY_RADICAL = 0xFF }
enum | AABondType { BT_NONE = 0 , SINGLE = 1 , DOUBLE = 2 , TRIPLE = 3 , AROMATIC = 4 , SINGLE_DOUBLE = 5 , SINGLE_AROMATIC = 6 , DOUBLE_AROMATIC = 7 , ANY_BOND = 8 , ALL_BOND_TYPES = 0xF }
enum | AATopology { TP_NONE = 0 , RING = 1 , CHAIN = 2 }

## Functions
RDKIT_STRUCTCHECKER_EXPORT RDKit::Bond::BondType | convertBondType (AABondType bt)
RDKIT_STRUCTCHECKER_EXPORT AABondType | convertBondType (RDKit::Bond::BondType rdbt)
RDKIT_STRUCTCHECKER_EXPORT unsigned | getAtomicNumber (const std::string symbol)
RDKIT_STRUCTCHECKER_EXPORT bool | AtomSymbolMatch (const std::string symbol, const std::string pattern)
RDKIT_STRUCTCHECKER_EXPORT bool | LigandMatches (const Atom &a, const Bond &b, const Ligand &l, bool use_charge=false)
RDKIT_STRUCTCHECKER_EXPORT bool | isBondTypeMatch (const RDKit::Bond &b, AABondType lbt)
RDKIT_STRUCTCHECKER_EXPORT bool | RecMatch (const ROMol &mol, unsigned atomIdx, const AugmentedAtom &aa, const std::vector< Neighbourhood > &nbp, bool verbose)
RDKIT_STRUCTCHECKER_EXPORT bool | AAMatch (const ROMol &mol, unsigned i, const AugmentedAtom &aa, const std::vector< unsigned > &atom_ring_status, const std::vector< Neighbourhood > &nbp, bool verbose)
RDKIT_STRUCTCHECKER_EXPORT bool | TransformAugmentedAtoms (RWMol &mol, const std::vector< std::pair< AugmentedAtom, AugmentedAtom > > &aapair, bool verbose)
RDKIT_STRUCTCHECKER_EXPORT bool | CheckAtoms (const ROMol &mol, const std::vector< AugmentedAtom > &good_atoms, bool verbose)
int | TotalCharge (const ROMol &mol)
static int | INVERT_PARITY (int p)
RDKIT_STRUCTCHECKER_EXPORT int | DubiousStereochemistry (RWMol &mol)
RDKIT_STRUCTCHECKER_EXPORT int | FixDubious3DMolecule (RWMol &mol)
RDKIT_STRUCTCHECKER_EXPORT void | RemoveDubiousStereochemistry (RWMol &mol)
RDKIT_STRUCTCHECKER_EXPORT bool | CheckStereo (const ROMol &mol)
RDKIT_STRUCTCHECKER_EXPORT bool | AtomClash (RWMol &mol, double clash_limit)
RDKIT_STRUCTCHECKER_EXPORT int | AtomParity (const ROMol &mol, unsigned iatom, const Neighbourhood &nbp)
RDKIT_STRUCTCHECKER_EXPORT int | CisTransPerception (const ROMol &mol, const std::vector< RDGeom::Point3D > &points, const std::vector< unsigned > &numbering, std::vector< unsigned > &bondColor)
RDKIT_STRUCTCHECKER_EXPORT bool | StripSmallFragments (RWMol &mol, bool verbose=false)
RDKIT_STRUCTCHECKER_EXPORT void | AddMWMF (RWMol &mol, bool pre)
RDKIT_STRUCTCHECKER_EXPORT bool | parseOptionsJSON (const std::string &json, StructCheckerOptions &op)
RDKIT_STRUCTCHECKER_EXPORT bool | loadOptionsFromFiles (StructCheckerOptions &op, const std::string &augmentedAtomTranslationsFile="", const std::string &patternFile="", const std::string &rotatePatternFile="", const std::string &stereoPatternFile="", const std::string &tautomerFile="")
RDKIT_STRUCTCHECKER_EXPORT bool | StringToAugmentedAtom (const char *str, AugmentedAtom &aa)
RDKIT_STRUCTCHECKER_EXPORT void | SetupNeighbourhood (const ROMol &mol, std::vector< Neighbourhood > &neighbour_array)
RDKIT_STRUCTCHECKER_EXPORT bool | getMolAtomPoints (const ROMol &mol, std::vector< RDGeom::Point3D > &atomPoint, bool twod=false)
RDKIT_STRUCTCHECKER_EXPORT std::string | LogNeighbourhood (const ROMol &mol, unsigned int idx, const std::vector< Neighbourhood > &bneighbour_array)

## Variables
static const int | ODD = 1
static const int | EVEN = 2
static const int | UNMARKED = 3
static const int | ALLENE_PARITY = -2
static const int | ILLEGAL_REPRESENTATION = -1
static const int | UNDEFINED_PARITY = 0
static const int | ODD_PARITY = 1
static const int | EVEN_PARITY = 2
static const int | CIS = 1
static const int | TRANS = 2
static const int | EITHER_BOND_FOUND = 1
static const int | STEREO_BOND_AT_NON_STEREO_ATOM = 2
static const int | ZEROED_Z_COORDINATES = 4
static const int | CONVERTED_TO_2D = 8
static const int | ANY_CHARGE = 8

## Enumeration Type Documentation

## ◆ AABondType

enum RDKit::StructureCheck::AABondType

Enumerator
BT_NONE |
SINGLE |
DOUBLE |
TRIPLE |
AROMATIC |
SINGLE_DOUBLE |
SINGLE_AROMATIC |
DOUBLE_AROMATIC |
ANY_BOND |
ALL_BOND_TYPES |

Definition at line 44 of file StructChecker.h.

## ◆ AATopology

enum RDKit::StructureCheck::AATopology

Enumerator
TP_NONE |
RING |
CHAIN |

Definition at line 57 of file StructChecker.h.

## ◆ RadicalType

enum RDKit::StructureCheck::RadicalType

Enumerator
RT_NONE |
SINGLET |
DOUBLET |
TRIPLET |
ANY_RADICAL |

Definition at line 36 of file StructChecker.h.

## Function Documentation

## ◆ AAMatch()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::AAMatch | ( | const ROMol & | mol,
|  | unsigned | i,
|  | const AugmentedAtom & | aa,
|  | const std::vector< unsigned > & | atom_ring_status,
|  | const std::vector< Neighbourhood > & | nbp,
|  | bool | verbose )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ AddMWMF()

RDKIT_STRUCTCHECKER_EXPORT void RDKit::StructureCheck::AddMWMF | ( | RWMol & | mol,
|  | bool | pre )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ AtomClash()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::AtomClash | ( | RWMol & | mol,
|  | double | clash_limit )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ AtomParity()

RDKIT_STRUCTCHECKER_EXPORT int RDKit::StructureCheck::AtomParity | ( | const ROMol & | mol,
|  | unsigned | iatom,
|  | const Neighbourhood & | nbp )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ AtomSymbolMatch()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::AtomSymbolMatch | ( | const std::string | symbol,
|  | const std::string | pattern )

References RDKIT_STRUCTCHECKER_EXPORT, and symbol.

## ◆ CheckAtoms()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::CheckAtoms | ( | const ROMol & | mol,
|  | const std::vector< AugmentedAtom > & | good_atoms,
|  | bool | verbose )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ CheckStereo()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::CheckStereo | ( | const ROMol & | mol | ) |

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ CisTransPerception()

RDKIT_STRUCTCHECKER_EXPORT int RDKit::StructureCheck::CisTransPerception | ( | const ROMol & | mol,
|  | const std::vector< RDGeom::Point3D > & | points,
|  | const std::vector< unsigned > & | numbering,
|  | std::vector< unsigned > & | bondColor )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ convertBondType() [1/2]

RDKIT_STRUCTCHECKER_EXPORT RDKit::Bond::BondType RDKit::StructureCheck::convertBondType | ( | AABondType | bt | ) |

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ convertBondType() [2/2]

RDKIT_STRUCTCHECKER_EXPORT AABondType RDKit::StructureCheck::convertBondType | ( | RDKit::Bond::BondType | rdbt | ) |

## ◆ DubiousStereochemistry()

RDKIT_STRUCTCHECKER_EXPORT int RDKit::StructureCheck::DubiousStereochemistry | ( | RWMol & | mol | ) |

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ FixDubious3DMolecule()

RDKIT_STRUCTCHECKER_EXPORT int RDKit::StructureCheck::FixDubious3DMolecule | ( | RWMol & | mol | ) |

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ getAtomicNumber()

RDKIT_STRUCTCHECKER_EXPORT unsigned RDKit::StructureCheck::getAtomicNumber | ( | const std::string | symbol | ) |

References RDKIT_STRUCTCHECKER_EXPORT, and symbol.

## ◆ getMolAtomPoints()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::getMolAtomPoints | ( | const ROMol & | mol,
|  | std::vector< RDGeom::Point3D > & | atomPoint,
|  | bool | twod = false )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ INVERT_PARITY()

static int RDKit::StructureCheck::INVERT_PARITY | ( | int | p | ) |
| inlinestatic

Definition at line 28 of file Stereo.h.

## ◆ isBondTypeMatch()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::isBondTypeMatch | ( | const RDKit::Bond & | b,
|  | AABondType | lbt )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ LigandMatches()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::LigandMatches | ( | const Atom & | a,
|  | const Bond & | b,
|  | const Ligand & | l,
|  | bool | use_charge = false )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ loadOptionsFromFiles()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::loadOptionsFromFiles | ( | StructCheckerOptions & | op,
|  | const std::string & | augmentedAtomTranslationsFile = "",
|  | const std::string & | patternFile = "",
|  | const std::string & | rotatePatternFile = "",
|  | const std::string & | stereoPatternFile = "",
|  | const std::string & | tautomerFile = "" )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ LogNeighbourhood()

RDKIT_STRUCTCHECKER_EXPORT std::string RDKit::StructureCheck::LogNeighbourhood | ( | const ROMol & | mol,
|  | unsigned int | idx,
|  | const std::vector< Neighbourhood > & | bneighbour_array )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ parseOptionsJSON()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::parseOptionsJSON | ( | const std::string & | json,
|  | StructCheckerOptions & | op )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ RecMatch()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::RecMatch | ( | const ROMol & | mol,
|  | unsigned | atomIdx,
|  | const AugmentedAtom & | aa,
|  | const std::vector< Neighbourhood > & | nbp,
|  | bool | verbose )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ RemoveDubiousStereochemistry()

RDKIT_STRUCTCHECKER_EXPORT void RDKit::StructureCheck::RemoveDubiousStereochemistry | ( | RWMol & | mol | ) |

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ SetupNeighbourhood()

RDKIT_STRUCTCHECKER_EXPORT void RDKit::StructureCheck::SetupNeighbourhood | ( | const ROMol & | mol,
|  | std::vector< Neighbourhood > & | neighbour_array )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ StringToAugmentedAtom()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::StringToAugmentedAtom | ( | const char * | str,
|  | AugmentedAtom & | aa )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ StripSmallFragments()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::StripSmallFragments | ( | RWMol & | mol,
|  | bool | verbose = false )

References RDKIT_STRUCTCHECKER_EXPORT.

## ◆ TotalCharge()

int RDKit::StructureCheck::TotalCharge | ( | const ROMol & | mol | ) |

## ◆ TransformAugmentedAtoms()

RDKIT_STRUCTCHECKER_EXPORT bool RDKit::StructureCheck::TransformAugmentedAtoms | ( | RWMol & | mol,
|  | const std::vector< std::pair< AugmentedAtom, AugmentedAtom > > & | aapair,
|  | bool | verbose )

References RDKIT_STRUCTCHECKER_EXPORT.

## Variable Documentation

## ◆ ALLENE_PARITY

const int RDKit::StructureCheck::ALLENE_PARITY = -2
| static

Definition at line 23 of file Stereo.h.

## ◆ ANY_CHARGE

const int RDKit::StructureCheck::ANY_CHARGE = 8
| static

Definition at line 35 of file StructChecker.h.

Referenced by RDKit::StructureCheck::AugmentedAtom::AugmentedAtom(), and RDKit::StructureCheck::Ligand::Ligand().

## ◆ CIS

const int RDKit::StructureCheck::CIS = 1
| static

Definition at line 31 of file Stereo.h.

## ◆ CONVERTED_TO_2D

const int RDKit::StructureCheck::CONVERTED_TO_2D = 8
| static

Definition at line 38 of file Stereo.h.

## ◆ EITHER_BOND_FOUND

const int RDKit::StructureCheck::EITHER_BOND_FOUND = 1
| static

Definition at line 35 of file Stereo.h.

## ◆ EVEN

const int RDKit::StructureCheck::EVEN = 2
| static

Definition at line 20 of file Stereo.h.

## ◆ EVEN_PARITY

const int RDKit::StructureCheck::EVEN_PARITY = 2
| static

Definition at line 27 of file Stereo.h.

## ◆ ILLEGAL_REPRESENTATION

const int RDKit::StructureCheck::ILLEGAL_REPRESENTATION = -1
| static

Definition at line 24 of file Stereo.h.

## ◆ ODD

const int RDKit::StructureCheck::ODD = 1
| static

Definition at line 19 of file Stereo.h.

## ◆ ODD_PARITY

const int RDKit::StructureCheck::ODD_PARITY = 1
| static

Definition at line 26 of file Stereo.h.

## ◆ STEREO_BOND_AT_NON_STEREO_ATOM

const int RDKit::StructureCheck::STEREO_BOND_AT_NON_STEREO_ATOM = 2
| static

Definition at line 36 of file Stereo.h.

## ◆ TRANS

const int RDKit::StructureCheck::TRANS = 2
| static

Definition at line 32 of file Stereo.h.

## ◆ UNDEFINED_PARITY

const int RDKit::StructureCheck::UNDEFINED_PARITY = 0
| static

Definition at line 25 of file Stereo.h.

## ◆ UNMARKED

const int RDKit::StructureCheck::UNMARKED = 3
| static

Definition at line 21 of file Stereo.h.

## ◆ ZEROED_Z_COORDINATES

const int RDKit::StructureCheck::ZEROED_Z_COORDINATES = 4
| static

Definition at line 37 of file Stereo.h.